<?php

/**
 * Класс Pactioner предназначен для выполнения действий,  AJAX запросов плагина
 *
 */
class Pactioner extends Actioner
{
	private $pluginName = 'bifitkassa'; // Имя плагина

	/**
	 * (AJAX) Получает значения записи по ID
	 * @return boolean
	 */
	public function getEntity()
	{
		// Получаем параметры запроса
		$request = $_POST;

		// Составляем запрос
		$res = DB::query(
			'
			SELECT * 
			FROM `' .
				PREFIX .
				$this->pluginName .
				'`
			WHERE `id` = ' .
				DB::quoteInt($request['id'])
		);

		// Выполняем запрос
		if ($row = DB::fetchAssoc($res)) {
			// Если выполнилось, возвращаем результат и статус "успех"
			$this->data = $row;
			return true;
		} else {
			//...иначе возвращаем статус "ошибка"
			return false;
		}

		return false;
	}

	/**
	 * (AJAX) Удаление записи
	 * @return boolean
	 */
	public function deleteEntity()
	{
		// Сообщения для нотификаций успеха или ошибки
		$this->messageSucces = $this->lang['ENTITY_DEL'];
		$this->messageError = $this->lang['ENTITY_DEL_NOT'];

		// Получаем параметры запроса
		$request = $_POST;

		// Выполняем запрос на удаление и возвращаем соответствующий статус
		if (
			DB::query(
				'DELETE FROM `' .
					PREFIX .
					$this->pluginName .
					'` WHERE `id`= ' .
					DB::quoteInt($request['id'])
			)
		) {
			return true;
		}

		return false;
	}

	/**
	 * Сохраняет опции плагина
	 * @return boolean
	 */
	public function saveBaseOption()
	{
		// Доступно только модераторам и админам.
		USER::AccessOnly('1,4,3', 'exit()');

		// Сообщения для нотификаций успеха или ошибки
		$this->messageSucces = $this->lang['SAVE_BASE'];
		$this->messageError = $this->lang['NOT_SAVE_BASE'];

		// Получаем параметры запроса
		$request = $_POST;

		// Проверяем наличие данных для опций
		if (!empty($request['data'])) {
			// Валидация опции "Токен"
			if ($request['data']['token'] == "") {
				// Изменяем текст ошибки и возвращаем статус "ошибка"
				$this->messageError = $this->lang['VALID_TOKEN_ERROR'];
				return false;
			}
			// Валидация опции "ФИО Кассира"
			if ($request['data']['cashier_name'] == "") {
				// Изменяем текст ошибки и возвращаем статус "ошибка"
				$this->messageError = $this->lang['VALID_CASHIER_NAME_ERROR'];
				return false;
			}
			// Валидация опции "ИНН Кассира"
			if ($request['data']['cashier_inn'] == "") {
				// Изменяем текст ошибки и возвращаем статус "ошибка"
				$this->messageError = $this->lang['VALID_CASHIER_INN_ERROR'];
				return false;
			}
			// Валидация опции "Место расчётов"
			if ($request['data']['payment_address'] == "") {
				// Изменяем текст ошибки и возвращаем статус "ошибка"
				$this->messageError =
					$this->lang['VALID_PAYMENT_ADDRESS_ERROR'];
				return false;
			}
			// Устанавливаем новые опции
			MG::setOption(array(
				'option' => $this->pluginName . '-option',
				'value' => addslashes(serialize($request['data']))
			));
		}

		// Возвращаем статус "успешно"
		return true;
	}

	/**
	 * (AJAX) Устанавливает количество отображаемых записей в разделе
	 * @return boolean
	 */
	public function setCountPrintRowsEnity()
	{
		// Количество записей на странице по умолчанию
		$count = 20;

		// Валидация полученого значения
		if (is_numeric($_POST['count']) && !empty($_POST['count'])) {
			$count = $_POST['count'];
		}

		// Устанавливаем кол. в опциях
		MG::setOption(array('option' => $_POST['option'], 'value' => $count));

		// Возвращаем статус "успешно"
		return true;
	}

	/**
	 * (AJAX) Устанавливает количество отображаемых записей в разделе
	 * @return boolean
	 */
	public function updateOrganizations()
	{
		// Получаем опции плагина в специальном формате
		$option = MG::getSetting($this->pluginName . '-option');

		// Преобразуем в массив
		$option = stripslashes($option);
		$options = unserialize($option);

		// Обновляем данные по организациям
		Bifit::__getOrgsData($options, null, null, 1);

		// Возвращаем статус "успешно"
		return true;
	}

	/**
	 * (AJAX) Устанавливает новый список торговых объектов
	 * @return boolean
	 */
	public function setNewOrganization()
	{
		// Валидация полученого значения
		if (isset($_POST['org_id']) && !empty($_POST['org_id'])) {
			// Получаем опции плагина в специальном формате
			$option = MG::getSetting($this->pluginName . '-option');

			// Преобразуем в массив
			$option = stripslashes($option);
			$options = unserialize($option);

			$options['organization'] = $_POST['org_id'];

			MG::setOption(array(
				'option' => $this->pluginName . '-option',
				'value' => addslashes(serialize($options))
			));
		}

		// Возвращаем статус "успешно"
		return true;
	}
}
